//+------------------------------------------------------------------+
//| NonLagMA-Histogram                                                                 |
//| original NonLag moving average developed by igorad               |
//| this version made by mladen                                      | 
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  OrangeRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Length          = 15;
extern int    Price           = PRICE_CLOSE;
extern double PctFilter       = 0;
extern bool   Invert          = false;
extern string ForSymbol       = "";
extern bool   alertsOn        = false; //true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double NonLagMaBuffer[];
double NonLagMaBufferHu[];
double NonLagMaBufferHd[];
double trend[];
double delta[];
double avgDelta[];
double alphas[];

//
//
//
//
//

string indicatorFileName;
double multiplier=1;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,NonLagMaBufferHu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,NonLagMaBufferHd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,NonLagMaBuffer);
   SetIndexBuffer(3,trend);
   SetIndexBuffer(4,delta);
   SetIndexBuffer(5,avgDelta);
   
      //
      //
      //
      //
      //

         if (Invert)          multiplier = -1;      
         if (ForSymbol == "") ForSymbol  = Symbol();
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //

   string isInverted = "";
      if (Invert) isInverted = " inverted ";               
   IndicatorShortName(timeFrameToString(timeFrame)+" "+isInverted+ ForSymbol+" NLMA ("+Length+")");
   return(0);  
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { NonLagMaBufferHu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      limit = MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,0,indicatorFileName,"returnBars",0,0)));
      for (i=limit; i>=0; i--)
      {
         NonLagMaBuffer[i]   = iNoLagMa(iMA(ForSymbol,0,1,0,MODE_SMA,Price,i),Length,alphas,0,i);
         NonLagMaBufferHu[i] = EMPTY_VALUE;
         NonLagMaBufferHd[i] = EMPTY_VALUE;

         //
         //
         //
         //
         //
          
         if (PctFilter>0)
         {
            delta[i] = MathAbs(NonLagMaBuffer[i] - NonLagMaBuffer[i+1]);
            
            double sumdelta=0;
               for (j=0; j<Length; j++) sumdelta += delta[i+j];
                              avgDelta[i] = sumdelta/Length;
            double sumpow = 0;
               for (j=0; j<Length; j++) sumpow+=MathPow(delta[i+j]-avgDelta[i+j],2);
            
            double deviation = MathSqrt(sumpow/Length); 
            double filter    = PctFilter * deviation;
            
               if(MathAbs(NonLagMaBuffer[i]-NonLagMaBuffer[i+1]) < filter ) NonLagMaBuffer[i]=NonLagMaBuffer[i+1];
         }

         //
         //
         //
         //
         //
         
         trend[i] = trend[i+1];
            if (NonLagMaBuffer[i]>NonLagMaBuffer[i+1]) trend[i]= 1*multiplier;
            if (NonLagMaBuffer[i]<NonLagMaBuffer[i+1]) trend[i]=-1*multiplier;
            if (trend[i]== 1) NonLagMaBufferHu[i]=1;
            if (trend[i]==-1) NonLagMaBufferHd[i]=1;
      }            
      manageAlerts();
   	return(0);	
   }	  

   //
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         NonLagMaBufferHu[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue",Length,Price,PctFilter,Invert,"",false,0,y);
         NonLagMaBufferHd[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue",Length,Price,PctFilter,Invert,"",false,1,y);
         trend[i]            = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue",Length,Price,PctFilter,Invert,"",false,3,y);
   }
   manageAlerts();
   
   //
   //
   //
   //
   //
      
   return(0);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double values[][3];
double prices[][1];

#define Pi       3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2

//
//
//
//
//

double iNoLagMa(double price, int length, double &alphasArray[], int forValue, int i)
{
   if (ArrayRange(prices,0) != Bars) ArrayResize(prices,Bars);
            int r = Bars-i-1;  prices[r][forValue]=price;
   if (length<3 || r<3) return(prices[r][forValue]);
   
   //
   //
   //
   //
   //
   
   if (ArrayRange(values,0)<(forValue+1) || values[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(values,0)<forValue+1) ArrayResize(values,forValue+1);

         values[forValue][_length] = length;
         values[forValue][_len]    = length*4 + Phase;  
         values[forValue][_weight] = 0;  
         ArrayResize(alphasArray,values[forValue][_len]);

         for (int k=0; k<values[forValue][_len]-1; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            alphasArray[k]             = g * beta;
            values[forValue][_weight] += alphasArray[k];
         }
   }
   
   //
   //
   //
   //
   //
   
   if (values[forValue][_weight]>0)
   {
      int    len = values[forValue][_len];
      double sum = 0;
           for (k=0; k < len-1; k++) sum += alphasArray[k]*prices[r-k][forValue];      
           return( sum / values[forValue][_weight]);
   }
   else return(0);           
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(ForSymbol," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," NonLagMA changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(ForSymbol,"NonLagMA "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}